var Fs = require('fs');
var Yaml = require('libyaml');
exports.ApplicationConfig = function(params){
    var configPath = params.path + "/app.yaml";
    var configFile = null;
    var configuration = null;
    try{
        configFile = Fs.readFileSync(configPath, "utf8");
        configuration = Yaml.load(configFile)[0];   
    }
    catch(err){
        Exit.applicationError(2003, "Problem with application configuration. Check: " + configPath);
    }
    if(configuration.hasOwnProperty('handler')){
        var parts = configuration.handler.split("#");
        if(parts.length == 2){
            configuration.handler = {};
            configuration.handler.moduleName = parts[0];
            configuration.handler.className = parts[1];
        }
        else{
            Exit.applicationError(2003, "Invalid application configuration. Missing ClassName param in \"handler\" filed. Check app.yaml");
        }
    }
    else{
        Exit.applicationError(2002, "Invalid application configuration. There is no \"handler\" field. Check app.yaml");
    }
    return configuration;
};