var Fs = require('fs');
exports.BootConfigManager = function(){
    var fileName = "/tmp/bootstrapinfo.json";
    var config = null;
    var timeoutCallbacks = {};
    this.load = function(){
        try {
            var configFile = Fs.readFileSync(fileName, "utf8");
            config = JSON.parse(configFile);   
        }
        catch(err){
            //Exit.systemError(100, "Problem with bootstrapinfo.json: " + err);
            config = {};
            this.save();
        }
    };
    this.save = function(){
        var data = JSON.stringify(config);
        Fs.writeFileSync(fileName, data);        
    };
    this.getApplicationInfo = function(path, host, port){
        if(!config){
            this.load();
        }
        var result = [];
        if(!config.hasOwnProperty(path)){
            return result;
        }
        var apps = config[path];
        for(var i = 0; i < apps.length; i++){
            if(host && port){
                if(apps[i].host == host && (apps[i].port == port)){
                    result.push(apps[i]);
                }
            }
            else {
                result.push(apps[i]);
            }
        }   
        return result;
    };
    this.setApplicationInfo = function(path, host, port, pid, id, token){
        if(!config){
            this.load();
        }
        if(!config.hasOwnProperty(path)){
            config[path] = [];
        }
        var location = host+":"+port;
        config[path].push({
            "host":host,
            "port":port,
            "pid": pid,
            "id" : id,
            "token" : token
        });
    };
    this.removeApplicationInfo = function(path, pid){
        if(!config){
            this.load();
        }
        try{
            var i = 0;
            var count = config[path].length;
            while(i < count && pid != config[path][i].pid ){
                i++;
            } 
            if(i < count){
                config[path].splice(i,1);    
            }
        }
        catch(err){}
    };
    this.onUpdate = function(path, host, port, token, callback, counter){
        that = this;
        counter = counter ? counter : 0;
        if(counter > 10){
            timeoutCallbacks[token](token);
        }
        setTimeout(function(){
            that.load();
            var info = that.getApplicationInfo(path, host, port);
            if(info.length > 0){
                for(var i = 0; i < info.length; i++){
                    if(info[i].token == token){
                        callback(info[i]);
                        return;
                    }
                }  
            }
            counter++;
            that.onUpdate(path, host, port, token, callback, counter);
        }, 100);  
    };
    this.onUpdateTimeout = function(token, callback){
          timeoutCallbacks[token] = callback;
    };
    this.toString = function(){
        console.log('>>>>', config);  
    };
    return this;
};